static char resid[]="$Header: /grass.src/4.1/src.related/mapgen/SCS/plotter/RCS/DGRASS.c,v 1.1 1993/05/07 17:32:10 grassb Exp grassb $"; 

/* @(#)main.c	2.2   7/24/87 */
/* driver modified for nri software */
/* the following defines must be included for all drivers */
/* modified for multiple paper sizes */
#include <varargs.h>
#include "plotter.h"
#define TEMP "/tmp/GRASS"
/*#define MAXPEN 256*/ 
#define TOTPEN 256
/* mlh addition */
#define MARGIN 5
#define MAXNAMLEN 255
/* mlh addition */
/* All references to MAXPEN changed to TOTPEN*/


#include <stdio.h>
#include "gis.h"


static char s[200] = "\0";		/* required structure for return */
static XYS cursor = {0, 0, s};	/* data.  "s" may be larger, if needed */
	/* basic screen ranges */
int XPMAX = 600;
int YPMAX = 500;
int t, b, l, r;
char cname[50], name[MAXNAMLEN], *base, buff[MAXNAMLEN];

static void plot_all(c,x,y)
char c;
int x, y;

{
	 switch (c) {
		case 'c':
			R_color(x);
			break;
		case 'm':
			R_move_abs(x,y);
			break;
		case 'l':
			R_cont_abs(x,y);
			break;
		}
}

static void initGRASS()
{
int cr,cb,cg,i;
FILE *colorfp, *fopen();
struct Gcolorfple {
	int r,g,b;
	} ctable[TOTPEN];
/* Initialize the GIS calls */
	G_gisinit("MAPGEN") ;



/* Make sure map is available */

    R_open_driver();



/* Read in the map window associated with window */


/* Determine window */
	
	if (D_get_screen_window(&t, &b, &l, &r))
		G_fatal_error("Getting screen window") ;
/*
	XPMAX = r - l +1;
	YPMAX = b - t +1;
*/
/* mlh addition */
        XPMAX = r - l - MARGIN;
        YPMAX = b - t - MARGIN;
/* mlh addition */


/* DEBUG  fprintf(stderr,"t%d b%d l%d r%d\n",t,b,l,r);*/

/* Check for and read dig header info */


/*read color table if present*/

/*************** START color handler *****************/

/************* GET the default then user specified PEN/color mapping **/
/* Note: this replaces color setup in driver and gives greater flexibility */
if ((base = getenv("GISBASE")) != NULL) {
        sprintf(buff,"%s/mapgen/etc/Colortable",base);
        if ((colorfp = fopen(buff,"r")) != NULL) {
                while (fgets(name,MAXNAMLEN,colorfp) != NULL){
                        sscanf(name,"%d %d %d %d %[^\n]",&cr,&cg,&cb,&i,cname);
                        if (i < 256 && i > 0) {
				ctable[i].r = cr;
				ctable[i].g = cg;
				ctable[i].b = cb;
				}
		}
		for (i=0;i<256;i++) 
			R_reset_color(ctable[i].r,ctable[i].g,ctable[i].b,i);
		}

                fclose(colorfp);
  }
if ((colorfp = fopen(".colortable","r")) != NULL) {
                while (fgets(name,MAXNAMLEN,colorfp) != NULL){
                        sscanf(name,"%d %d %d %d %[^\n]",&cr,&cg,&cb,&i,cname);
                        if (i < 256 && i > 0) {
				ctable[i].r = cr;
				ctable[i].g = cg;
				ctable[i].b = cb;
				}
		}
		for (i=0;i<256;i++) 
			R_reset_color(ctable[i].r,ctable[i].g,ctable[i].b,i);
		}

        fclose(colorfp);
  }

static void endGRASS()
{
	R_flush();
    R_close_driver();
}


	XYS *
DGRASS(va_alist) va_dcl {
	va_list vap;
	int i, pen, xv, yv, cmd;
	XYS *ret = &cursor;
	char m, *LOCATION, *MNAME, scalefile[100];
	FILE *scalefp;

	va_start(vap); cmd = va_arg(vap, int);
/*DEBUG fprintf (stderr, "DGRASS %d\n",cmd);*/
	switch(cmd) {
	case D_INIT:
		pen = 1;
		initGRASS();
		plot_all('c',1);
	case D_SCALE:
/*this added for d_scale error */
	 LOCATION = getenv ("LOCATION");
         MNAME = getenv ("MNAME");
 	sprintf (scalefile,"%s/mapgen/%s/.d_scale",LOCATION,MNAME);
	if ((scalefp = fopen(scalefile,"w")) == NULL) {
		fprintf(stderr,"DGRASS: Warning can not open scale file\n");
		fprintf(stderr,"DGRASS: call you system adminitrator\n");
		}
	else {
		fprintf(scalefp,"%lf",Dglobal.scale);
		fclose(scalefp);
		}
/*DEBUG fprintf(stderr,"SCALE %lf\n",Dglobal.scale);*/
		if (Dglobal.scale <= 0.)
			Dglobal.scale = 1.;
		{ cursor.y = YPMAX; cursor.x = XPMAX; }
		cursor.x = cursor.x / Dglobal.scale + 1;
		cursor.y = cursor.y / Dglobal.scale + 1;
		break;

	case D_PANIC:
/*DEBUG fprintf (stderr, "in panic\n");*/
	case D_DISABL:
/*DEBUG fprintf (stderr, "in disable\n");*/
	case D_DONE:
		endGRASS();
		break;

	case D_MOVE:
		m = 'm';
		goto draw;

	case D_LINE:
		m = 'l';
draw:		xv = va_arg(vap, long) * Dglobal.scale;
		yv = va_arg(vap, long) * Dglobal.scale;
		yv = YPMAX - yv + t -1;
		xv = xv + l -1;
		plot_all(m,xv,yv);
/*DEBUG   fprintf (stderr, "in line (%d,%d) (%d,%d)\n %lf\n", XPMAX, YPMAX,  xv, yv, Dglobal.scale); */
		break;
	case D_ERASE:
/*DEBUG fprintf (stderr, "in erase \n", xv, yv);*/
		break;
	case D_PEN:
		pen = va_arg(vap, long);
/*DEBUG fprintf (stderr, "in pen %d \n", pen);*/
		while (pen > TOTPEN) pen -= TOTPEN;
/*DEBUG fprintf (stderr, "in pen %d \n", pen);*/
		plot_all('c',pen);
		break;
	case D_CURSOR:
/*DEBUG fprintf (stderr, "in cursor (%d, %d)\n", cursor.x, cursor.y);*/
		break;
	default:
		break;
	}
	return ret;
}

