# ifndef lint
static char *SCCSID = "@(#)Dagfa.c	SCS ";
# endif
/* psqms - driver for Agfa PostScript Emerald RIP output */
# define PLOTTER

# include <varargs.h>
# include "plotter.h"

/*Added to set up more paper sizes*/
#define XPMAX sheet[Dglobal.model_no].xpmax
#define XPIN sheet[Dglobal.model_no].xpin
#define YPMAX sheet[Dglobal.model_no].ypmax
#define YPIN sheet[Dglobal.model_no].ypin

/* establish number of typesetter points/inch.
** The following is the legal definition is 72.27 pts/in but some machines
** appear to use 72 (even) */
#define PTS_PER_IN 72.0
/* Convert 200 counts/cm to points: 2.54 * 200 */
#define IN_TO_CNTS      508.0


static struct SHEET {
        float   ypmax, xpmax, ypin, xpin;   /* axis size of paper in inches: 508 x in */
} sheet[] = {
	4319.,	5588.,	792.,	612.,	/* 11x8.5" standard or A size */
	5588.,	8636.,	1224.,	792.,	/* 17x11" B size */
	8636.,	11176.,	1584.,	1224.,	/* 22x17" C size */
	11176.,	17272.,	2448.,	1584.,	/* 34x22" D size */
	17272.,	22352.,	3168.,	2448.,	/* 44x34" E size */
	17272.,	30480.,	3672.,	2448.,	/* 51x34" Ex size */
};


static char s[] = "\0";		/* required structure for return */
static XYS cursor = {0, 0, s};	/* data.  "s" may be larger, if needed */
#define MAX_DXY 50
	static XY
dxy[MAX_DXY];
	static int
nline = 0,
ndxy = 0,
troff = 0,
noshow = 0,
oldpen = 0,
pen,
pendown;
static	float red[MAXPEN], green[MAXPEN], blue[MAXPEN], pens[MAXPEN];

/* initialization strings and PostScript abbreviations */
/* \004 tag set to indicate beginning of PostScript data */
/* Changed scale value to new plotter count value 72/508 */

 static char
*initstr = "%%!PS-Adobe-3.0 
%%%%Title: Untitled
%%%%Creator: GRASS*MAPGEN HP650c PostScript Driver
%%%%CreationDate:
%%%%Pages: (atend)
%%%%DocumentFonts: (atend)
%%%%BoundingBox: 0 0 %d %d
%%%%ProofMode: Substitute
%%%%DocumentPaperSizes: Letter.Extra
%%%%EndComments
%%%%BeginProlog
%% ############## GRASS*MAPGEN PostScript Header  #################
%%
%%%%EndProlog
%%%%BeginSetup
statusdict begin
/setpageparams known { %d %d 0 0 setpageparams }if
end
%%%%Page: 1 1
/SC { %.6g } def
/L { {rlineto} repeat currentpoint stroke moveto} bind def
/U { moveto } bind def
1 setlinecap
1 setlinejoin
%%%%EndSetup
gsave",
 
*init2 = " SC SC scale",

*end = "%%Trailer
%%DocumentFonts:
%%Pages: 1
%%EOF",
 
*portstr = "
0 %.1f translate
-90 rotate
",

*landstr = "";

	static void
dump() {
	int n;

	if (!ndxy) {
		if (pendown > 1)	return;
		dxy[0].x = dxy[0].y = 0;
		++ndxy;
	}
	n = ndxy;
	while (n--) /* print out in reverse order */
		if ((nline += printf("%d %d ",dxy[n].x,dxy[n].y)) > 70 && n) {
			(void)putchar('\n');
			nline = 0;
		}
	(void)printf("%d L\n",ndxy);
	nline = ndxy = 0;
	++pendown;
}
	static long
x, y, xl, yl, dx, dy;
	extern long
strtol();
static long mX=50,mY=50;

/******** MAIN plot driver routine ***********/
	XYS *
Dagfa(va_alist) va_dcl {
	va_list vap;
	int cmd, i;
	long lpen;
	XYS *ret = &cursor;
	char *ss;

	va_start(vap); cmd = va_arg(vap, int);
	switch(cmd) {
	case D_SCALE:
		if (Dglobal.scale <= 0.)	Dglobal.scale = 1.;
		goto scaleit;
	case D_INIT:
		SET_color();
		/*Dglobal.scale = Dglobal.scale / 2.0; commented out as test*/
		for (x = xl = mX, y = yl = mY, i = 1; i < Dglobal.dargc ; ++i)
			switch (*Dglobal.dargv[i]) {
			case 't':	/* troff mode */
				troff = 1;
				Dglobal.reverse = 1;
			case 'x':	/* suppress showpage */
				noshow = 1;
				break;
			case 'o':	/* offset -o<x>,<y> */
				ss = Dglobal.dargv[i];
				x = strtol(++ss, &ss, 0);
				y = strtol(++ss, &ss, 0);
				break;
			default:
				(void)fprintf(stderr,"unknown arg:%s\n",
					Dglobal.dargv[i]);
				ret = (XYS *)0;
			}
		if (!ret) break;
		pendown = 0;
		if (!troff)  printf(initstr,(int)XPIN,(int)YPIN,(int)YPIN,(int)XPIN,PTS_PER_IN/IN_TO_CNTS);
		puts(init2);

/* Changed for additional sheets sizes */

                if (Dglobal.reverse)
                        printf(portstr, YPMAX);
                else
                        puts(landstr);
                if (x || y)     (void)printf("%d %d translate\n",x,y);

	/*	if (!Dglobal.reverse) */
	/*		if (Dglobal.model_no == 1) (void)printf("0 %d translate\n-90 rotate\n",BTRANS); */
	/*		else (void)printf("0 %d translate\n-90 rotate\n",ATRANS); */
	/*	puts(portstr); */
	/*	if (x || y)	(void)printf("%d %d translate\n",x,y); */
/*End Change*/

scaleit:
		if (Dglobal.reverse) {
			cursor.y = (troff ? 10000 : XPMAX) / Dglobal.scale;
			cursor.x = (troff ? 10000 : YPMAX) / Dglobal.scale;
		} else {
			cursor.x = XPMAX / Dglobal.scale;
			cursor.y = YPMAX / Dglobal.scale;
		}
		break;
	case D_DONE:
	case D_PANIC:
		if (pendown)	dump();
		if (!troff)	puts("grestore\n");
		if (!noshow)	puts("showpage\n\004\n");
		if (!troff)	puts(end);
		break;
	case D_MOVE:
		if (pendown) {
			dump();
			pendown = 0;
		}
	case D_LINE:
		x = (va_arg(vap, long)) * Dglobal.scale + .5;
		y = (va_arg(vap, long)) * Dglobal.scale + .5;
		if (pendown) {
			if ((dx = x - xl) | (dy = y - yl)) {
				dxy[ndxy].x = dx;
				dxy[ndxy].y = dy;
				if (++ndxy >= MAX_DXY) dump();
			}
		} else {
			nline = printf("%d %d U ", x, y);
			pendown = 1;
		}
		xl = x;
		yl = y;
		break;
	case D_PEN:
		lpen = va_arg(vap, long);
		pen = lpen;
		while (pen > MAXPEN) pen -= MAXPEN;
		if (pen < 1) pen = 1;
		if (pen != oldpen) {
			if (pendown)	dump();
			if (red[pen-1] == 0.0 && green[pen-1] == 0.0 && blue[pen-1] == 0.0)
				(void)printf("%.3f setlinewidth 0 0 0 1 setcmykcolor\n",
				pens[pen-1]);
			else (void)printf("%.3f setlinewidth %.3f %.3f %.3f setrgbcolor\n",
					pens[pen-1],
					red[pen-1],
					green[pen-1],
					blue[pen-1]);
			pendown = 0;
			oldpen = pen;
		}
		break;
	}
	va_end(vap);
	return ret;
}

/*************** START color handler *****************/
SET_color()
{
FILE *colortab, *widthfp, *marfp;
int i,cg,cb,cr;
float x, y, ox, cw, oy;
char name[50];

for (i=0;i<256;i++){
	pens[i] = 2.0;

	REset_color(0,0,0,i);
	}
if ((marfp = fopen(".margin","r")) != NULL) {
	fscanf(marfp,"%f %f",&x,&y);
	ox = mX; oy = mY;
	mX = (long)(ox + (200.0 * x) * Dglobal.scale);
	mY = (long)(oy + (200.0 * y) * Dglobal.scale);
	fclose(marfp);
	}

if ((widthfp = fopen(".width","r")) != NULL) {
	while (fscanf(widthfp,"%f %d",&cw,&i) != EOF)
		if (i < 256 && i > 0) pens[i-1] = cw;
	fclose(widthfp);
	}

if ((colortab = fopen(".colortable","r")) == NULL) {
	REset_color(0,0,0,1); /*black*/
	REset_color(255,0,0,2); /*red*/
	REset_color(0,255,255,3); /*lightblue*/
	REset_color(0,255,0,4); /*green*/
	REset_color(0,0,255,5); /*blue*/
	REset_color(150,0,255,6); /*purple*/
	REset_color(99,99,99,7); /*gray*/
	REset_color(255,127,0,8); /*orange*/
	REset_color(0,255,175,9); /*aqua*/
	REset_color(255,0,150,10); /*magenta*/
	REset_color(255,255,0,11); /*yellow*/
	REset_color(100,200,50,12); /*lightgreen*/
	REset_color(255,127,255,13); /*lightorange*/
	REset_color(255,248,220,14); /*cornsilk*/
	REset_color(222,184,135,15); /*burlywood*/
	REset_color(255,64,64,16); /*brown*/
	REset_color(0,100,0,17); /*darkgreen*/
	REset_color(250,250,210,18); /*lightgoldenrodyellow*/
	REset_color(238,238,209,19); /*lightyellow2*/
	REset_color(238,232,170,20); /*palegoldenrod*/
	REset_color(238,220,130,21); /*lightgoldenrod2*/
	REset_color(139,129,76,22); /*lightgoldenrod4*/
	REset_color(139,139,122,23); /*lightyellow4*/
	REset_color(238,201,0,24); /*gold2*/
	REset_color(238,180,34,25); /*goldenrod2*/
	REset_color(238,173,14,26); /*darkgoldenrod2*/
	REset_color(139,105,20,27); /*goldenrod4*/
	REset_color(139,101,8,28); /*darkgoldenrod4*/
	REset_color(139,117,0,29); /*gold4*/
	REset_color(238,238,0,30); /*yellow2*/
	REset_color(139,139,0,31); /*yellow4*/
	REset_color(224,238,224,32); /*honeydew2*/
	REset_color(131,139,131,33); /*honeydew4*/
	REset_color(154,255,154,34); /*palegreen1*/
	REset_color(124,205,124,35); /*palegreen3*/
	REset_color(50,205,50,36); /*limegreen*/
	REset_color(154,205,50,37); /*yellowgreen*/
	REset_color(173,255,47,38); /*greenyellow*/
	REset_color(124,252,0,39); /*lawngreen*/
	REset_color(0,238,118,40); /*springgreen2*/
	REset_color(0,139,69,41); /*springgreen4*/
	REset_color(0,250,154,42); /*mediumspringgreen*/
	REset_color(60,179,113,43); /*mediumseagreen*/
	REset_color(78,238,148,44); /*seagreen2*/
	REset_color(46,139,87,45); /*seagreen4*/
	REset_color(0,139,0,46); /*green4*/
	REset_color(0,238,0,47); /*green2*/
	REset_color(34,139,34,48); /*forestgreen*/
	REset_color(105,139,105,49); /*darkseagreen4*/
	REset_color(180,238,180,50); /*darkseagreen2*/
	REset_color(143,188,143,51); /*darkseagreen*/
	REset_color(69,139,116,52); /*aquamarine4*/
	REset_color(118,238,198,53); /*aquamarine2*/
	REset_color(102,205,170,54); /*mediumaquamarine*/
	REset_color(105,139,34,55); /*olivedrab4*/
	REset_color(179,238,58,56); /*olivedrab2*/
	REset_color(110,139,61,57); /*darkolivegreen4*/
	REset_color(188,238,104,58); /*darkolivegreen2*/
	REset_color(139,37,0,59); /*orangered4*/
	REset_color(238,64,0,60); /*orangered2*/
	REset_color(139,90,0,61); /*orange4*/
	REset_color(238,154,0,62); /*orange2*/
	REset_color(139,69,0,63); /*darkorange4*/
	REset_color(238,118,0,64); /*darkorange2*/
	REset_color(255,140,0,65); /*darkorange*/
	REset_color(255,182,193,66); /*lightpink*/
	REset_color(238,162,173,67); /*lightpink2*/
	REset_color(139,95,101,68); /*lightpink4*/
	REset_color(255,192,203,69); /*pink*/
	REset_color(238,169,184,70); /*pink2*/
	REset_color(139,99,108,71); /*pink4*/
	REset_color(255,105,180,72); /*hotpink*/
	REset_color(238,106,167,73); /*hotpink2*/
	REset_color(139,58,98,74); /*hotpink4*/
	REset_color(238,18,137,75); /*deeppink2*/
	REset_color(139,10,80,76); /*deeppink4*/
	REset_color(238,149,114,77); /*lightsalmon2*/
	REset_color(139,87,66,78); /*lightsalmon4*/
	REset_color(250,128,114,79); /*salmon*/
	REset_color(238,130,98,80); /*salmon2*/
	REset_color(139,76,57,81); /*salmon4*/
	REset_color(233,150,122,82); /*darksalmon*/
	REset_color(255,228,225,83); /*mistyrose1*/
	REset_color(238,213,210,84); /*mistyrose2*/
	REset_color(139,125,123,85); /*mistyrose4*/
	REset_color(238,0,0,86); /*red2*/
	REset_color(205,0,0,87); /*red3*/
	REset_color(139,0,0,88); /*red4*/
	REset_color(255,99,71,89); /*tomato1*/
	REset_color(238,92,66,90); /*tomato2*/
	REset_color(139,54,38,91); /*tomato4*/
	REset_color(205,92,92,92); /*indianred*/
	REset_color(238,99,99,93); /*indianred2*/
	REset_color(205,85,85,94); /*indianred3*/
	REset_color(139,58,58,95); /*indianred4*/
	REset_color(219,112,147,96); /*palevioletred*/
	REset_color(238,121,159,97); /*palevioletred2*/
	REset_color(139,71,93,98); /*palevioletred4*/
	REset_color(199,21,133,99); /*mediumvioletred*/
	REset_color(139,34,82,100); /*violetred4*/
	REset_color(238,58,140,101); /*violetred2*/
	REset_color(208,32,144,102); /*violetred*/
	REset_color(238,130,238,103); /*violet*/
	REset_color(218,112,214,104); /*orchid*/
	REset_color(238,122,233,105); /*orchid2*/
	REset_color(205,105,201,106); /*orchid3*/
	REset_color(139,71,137,107); /*orchid4*/
	REset_color(186,85,211,108); /*mediumorchid*/
	REset_color(209,95,238,109); /*mediumorchid2*/
	REset_color(180,82,205,110); /*mediumorchid3$*/
	REset_color(122,55,139,111); /*mediumorchid4*/
	REset_color(104,34,139,112); /*darkorchid4*/
	REset_color(178,58,238,113); /*darkorchid2*/
	REset_color(153,50,204,114); /*darkorchid*/
	REset_color(160,32,240,115); /*purple*/
	REset_color(145,44,238,116); /*purple2*/
	REset_color(85,26,139,117); /*purple4*/
	REset_color(93,71,139,118); /*mediumpurple4*/
	REset_color(159,121,238,119); /*mediumpurple2*/
	REset_color(147,112,219,120); /*mediumpurple*/
	REset_color(148,0,211,121); /*darkviolet*/
	REset_color(138,43,226,122); /*blueviolet*/
	REset_color(25,25,112,123); /*midnightblue*/
	REset_color(0,0,128,124); /*navyblue*/
	REset_color(240,255,255,125); /*azure1*/
	REset_color(224,238,238,126); /*azure2*/
	REset_color(193,205,205,127); /*azure3*/
	REset_color(131,139,139,128); /*azure4*/
	REset_color(30,144,255,129); /*dodgerblue*/
	REset_color(30,144,255,130); /*dodgerblue1*/
	REset_color(28,134,238,131); /*dodgerblue2*/
	REset_color(24,116,205,132); /*dodgerblue3*/
	REset_color(16,78,139,133); /*dodgerblue4*/
	REset_color(176,196,222,134); /*lightsteelblue*/
	REset_color(202,225,255,135); /*lightsteelblue1*/
	REset_color(188,210,238,136); /*lightsteelblue2*/
	REset_color(162,181,205,137); /*lightsteelblue3*/
	REset_color(110,123,139,138); /*lightsteelblue4*/
	REset_color(70,130,180,139); /*steelblue*/
	REset_color(99,184,255,140); /*steelblue1*/
	REset_color(92,172,238,141); /*steelblue2*/
	REset_color(79,148,205,142); /*steelblue3*/
	REset_color(54,100,139,143); /*steelblue4*/
	REset_color(138,43,226,144); /*blueviolet*/
	REset_color(176,224,230,145); /*powderblue*/
	REset_color(176,224,210,146); /*powderblue2*/
	REset_color(100,149,237,147); /*cornflowerblue*/
	REset_color(100,149,217,148); /*cornflowerblue2*/
	REset_color(0,0,255,149); /*blue1*/
	REset_color(0,0,238,150); /*blue2*/
	REset_color(0,0,205,151); /*blue3*/
	REset_color(0,0,139,152); /*blue4*/
	REset_color(95,158,160,153); /*cadetblue*/
	REset_color(152,245,255,154); /*cadetblue1*/
	REset_color(142,229,238,155); /*cadetblue2*/
	REset_color(122,197,205,156); /*cadetblue3*/
	REset_color(83,134,139,157); /*cadetblue4*/
	REset_color(132,112,255,158); /*lightslateblue*/
	REset_color(123,104,238,159); /*mediumslateblue*/
	REset_color(72,61,139,160); /*darkslateblue*/
	REset_color(106,90,205,161); /*slateblue*/
	REset_color(131,111,255,162); /*slateblue1*/
	REset_color(122,103,238,163); /*slateblue2*/
	REset_color(105,89,205,164); /*slateblue3*/
	REset_color(71,60,139,165); /*slateblue4*/
	REset_color(135,206,250,166); /*lightskyblue*/
	REset_color(176,226,255,167); /*lightskyblue1*/
	REset_color(164,211,238,168); /*lightskyblue2*/
	REset_color(141,182,205,169); /*lightskyblue3*/
	REset_color(96,123,139,170); /*lightskyblue4*/
	REset_color(240,248,255,171); /*aliceblue*/
	REset_color(200,248,255,172); /*aliceblue2*/
	REset_color(200,248,235,173); /*aliceblue3*/
	REset_color(0,255,255,174); /*cyan1*/
	REset_color(0,238,238,175); /*cyan2*/
	REset_color(0,205,205,176); /*cyan3*/
	REset_color(0,139,139,177); /*cyan4*/
	REset_color(0,191,255,178); /*deepskyblue*/
	REset_color(0,191,255,179); /*deepskyblue1*/
	REset_color(0,178,238,180); /*deepskyblue2*/
	REset_color(0,154,205,181); /*deepskyblue3*/
	REset_color(0,104,139,182); /*deepskyblue4*/
	REset_color(173,216,230,183); /*lightblue*/
	REset_color(191,239,255,184); /*lightblue1*/
	REset_color(178,223,238,185); /*lightblue2*/
	REset_color(154,192,205,186); /*lightblue3*/
	REset_color(104,131,139,187); /*lightblue4*/
	REset_color(0,0,205,188); /*mediumblue*/
	REset_color(224,255,255,189); /*lightcyan*/
	REset_color(224,255,255,190); /*lightcyan1*/
	REset_color(209,238,238,191); /*lightcyan2*/
	REset_color(180,205,205,192); /*lightcyan3*/
	REset_color(122,139,139,193); /*lightcyan4*/
	REset_color(135,206,235,194); /*skyblue*/
	REset_color(135,206,255,195); /*skyblue1*/
	REset_color(126,192,238,196); /*skyblue2*/
	REset_color(108,166,205,197); /*skyblue3*/
	REset_color(74,112,139,198); /*skyblue4*/
	REset_color(65,105,225,199); /*royalblue*/
	REset_color(72,118,255,200); /*royalblue1*/
	REset_color(67,110,238,201); /*royalblue2*/
	REset_color(58,95,205,202); /*royalblue3*/
	REset_color(39,64,139,203); /*royalblue4*/
	REset_color(255,64,64,204); /*brown1*/
	REset_color(238,59,59,205); /*brown2*/
	REset_color(205,51,51,206); /*brown3*/
	REset_color(139,35,35,207); /*brown4*/
	REset_color(139,69,19,208); /*saddlebrown*/
	REset_color(244,164,96,209); /*sandybrown*/
	REset_color(188,143,143,210); /*rosybrown*/
	REset_color(255,193,193,211); /*rosybrown1*/
	REset_color(238,180,180,212); /*rosybrown2*/
	REset_color(205,155,155,213); /*rosybrown3*/
	REset_color(139,105,105,214); /*rosybrown4*/
	REset_color(255,211,155,215); /*burlywood1*/
	REset_color(238,197,145,216); /*burlywood2*/
	REset_color(139,115,85,217); /*burlywood4*/
	REset_color(205,170,125,218); /*burlywood3*/
	REset_color(255,228,196,219); /*bisque1*/
	REset_color(238,213,183,220); /*bisque2*/
	REset_color(205,183,158,221); /*bisque3*/
	REset_color(139,125,107,222); /*bisque4*/
	REset_color(255,231,186,223); /*wheat1*/
	REset_color(238,216,174,224); /*wheat2*/
	REset_color(205,186,150,225); /*wheat3*/
	REset_color(139,126,102,226); /*wheat4*/
	REset_color(238,232,205,227); /*cornsilk2*/
	REset_color(205,200,177,228); /*cornsilk3*/
	REset_color(139,136,120,229); /*cornsilk4*/
	REset_color(255,250,240,230); /*floralwhite*/
	REset_color(248,248,255,231); /*ghostwhite*/
	REset_color(245,245,245,232); /*whitesmoke*/
	REset_color(255,222,173,233); /*navajowhite1*/
	REset_color(238,207,161,234); /*navajowhite2*/
	REset_color(205,179,139,235); /*navajowhite3*/
	REset_color(139,121,94,236); /*navajowhite4*/
	REset_color(255,239,219,237); /*antiquewhite1*/
	REset_color(238,223,204,238); /*antiquewhite2*/
	REset_color(205,192,176,239); /*antiquewhite3*/
	REset_color(139,131,120,240); /*antiquewhite4*/
	REset_color(211,211,211,241); /*lightgray*/
	REset_color(119,136,153,242); /*lightslategray*/
	REset_color(112,128,144,243); /*slategray*/
	REset_color(198,226,255,244); /*slategray1*/
	REset_color(185,211,238,245); /*slategray2*/
	REset_color(159,182,205,246); /*slategray3*/
	REset_color(108,123,139,247); /*slategray4*/
	REset_color(82,139,139,248); /*darkslategray4*/
	REset_color(190,190,190,249); /*gray*/
	REset_color(170,170,170,250); /*gray*/
	REset_color(140,140,140,251); /*gray55*/
	REset_color(90,90,90,252); /*gray*/
	REset_color(51,51,51,253); /*gray20*/
	REset_color(20,20,20,254); /*gray8*/
	REset_color(0,0,0,255); /*gray4*/
	}
else{
	while (fscanf(colortab,"%d %d %d %d %s",&cr,&cg,&cb,&i,name) != EOF)
		if (i < 256 && i > 0) 
			REset_color(cr,cg,cb,i);
	fclose(colortab);
	}
}

REset_color(r,g,b,i)
int r,g,b,i;
{
float a;
int j;

j = i -1;
a = (float)r/256.0;
red[j] = a;
a = (float)g/256.0;
green[j] = a;
a = (float)b/256.0;
blue[j] = a;
}
/* End color Handler*/
