/*This is a program to generate blanking instructions. 
* The scale factors (FX FY) are set to 1.0 and
* the limits (lims[]) are setup for centimeters x 100 to convert float
*         Jill Schuler October 1994 
*/
#ifndef lint
static char *SCCSID = "@(#)Dblank.c	OEMG v.3.2";
#endif
/* the following defines must be included for all drivers */
/* modified for multiple paper sizes */

/* if SUN 
#include <stdlib.h>
#include <stdio.h>
*/

#include <varargs.h>
#include <termio.h>
#include <stdio.h>
#include <math.h>
#include "plotter.h"
#define file stdout
#define ifile stdin

# define BAUD B9600
#define NUM_PEN 256
#define MAXNAMLEN 255
#define XPMAX lims[Dglobal.model_no].xlim
#define YPMAX lims[Dglobal.model_no].ylim


static char s[] = "\0";		/* required structure for return */
static XYS cursor = {
	0, 0, s};	/* data.  "s" may be larger, if needed */
/*	select appropriate baud rate for your system */
static int oldpen;
static char *spen;
static  float red[MAXPEN], green[MAXPEN], blue[MAXPEN], pens[MAXPEN];
FILE *pentmp;
static struct {
	int	xlim,  ylim;
} lims[7] = {
	16256, 16256,           /* Ex paper 64x64*/
};

XYS *
Dblank(va_alist) va_dcl {
	va_list vap;
	int cmd, i, pen=1, px1,py1,px2,py2;
	double Dx, Dy, Dt;
	long	x, y, t;
	XYS *ret = &cursor;
	static double FX = 1.0;
	static double FY = 1.0;
	static double XOFF = 0.001;
	static double YOFF = 0.001;

	FILE *facp, *faco;
	char *GRAPH, *LOCATION, *MNAME, facfile[100], offfile[100], buf[256];

	va_start(vap);
	cmd = va_arg(vap, int);
	switch(cmd) {
	case D_SCALE:
		if (Dglobal.scale <= 0.)
			Dglobal.scale = 1.;
		goto scaleit;
	case D_INIT:
		fprintf(file,"##blanking command file generated from sites_geo file\n");



	oldpen = 1;

scaleit:
	if (Dglobal.reverse) {
		cursor.x = lims[Dglobal.model_no].ylim / Dglobal.scale * 2;
		cursor.y = lims[Dglobal.model_no].xlim / Dglobal.scale * 2;
	} else {
		cursor.x = lims[Dglobal.model_no].xlim / Dglobal.scale * 2;
		cursor.y = lims[Dglobal.model_no].ylim / Dglobal.scale * 2;
	}
	break;
case D_DONE:
	fprintf(file,".\n");
	fclose(file);
	break;
case D_MOVE:
	spen = ".\n#-x\n";
	goto moveit;
case D_LINE:
	/*spen = "PD";*/
	spen = "";
moveit:
	Dx = (va_arg(vap, long)) * Dglobal.scale;
	Dy = (va_arg(vap, long)) * Dglobal.scale;

	if (Dglobal.reverse) {
	/* Reverse option set with -r rotate */
		Dt = Dx;
		Dx = -(Dy + YOFF);
		Dy = (Dt - (lims[Dglobal.model_no].ylim) + XOFF);
	} else {
		/*Dx = Dx - (lims[Dglobal.model_no].xlim ) + XOFF;*/
		/*Dy = Dy - (lims[Dglobal.model_no].ylim ) + YOFF;*/
		Dx = (Dx + XOFF) / 200.0 ;
		Dy = (Dy + YOFF) / 200.0 ;
	}
	x = Dx * FX;
	y = Dy * FY;
	fprintf(file,"%s%0.3lf\t%0.3lf\n", spen, Dx, Dy);
	break;
}

va_end(vap);
return ret;
}

